aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorKristof Provost <kp@FreeBSD.org>2021-11-05 14:20:19 +0000
committerKristof Provost <kp@FreeBSD.org>2021-12-01 12:43:25 +0000
commit118090989817bfe9e3c3c8d68d70484a4999ce6b (patch)
tree31c2f5f87a2c22e8dcec37ace2b66bd6f46b6c1c
parent9684452504f94d197eefcd1f2e24ac4d03922d4b (diff)
downloadsrc-118090989817bfe9e3c3c8d68d70484a4999ce6b.tar.gz
src-118090989817bfe9e3c3c8d68d70484a4999ce6b.zip
net tests: basic if_stf test
Test the 6to4 code. MFC after: 3 weeks Sponsored by: Rubicon Communications, LLC ("Netgate") Differential Revision: https://reviews.freebsd.org/D32850 (cherry picked from commit eb5e0755f7496d1328d572b4d181c70b39152f08)
-rw-r--r--tests/sys/net/Makefile1
-rw-r--r--tests/sys/net/if_stf.sh84
2 files changed, 85 insertions, 0 deletions
diff --git a/tests/sys/net/Makefile b/tests/sys/net/Makefile
index 7340688286cc..ca50f6cbcd76 100644
--- a/tests/sys/net/Makefile
+++ b/tests/sys/net/Makefile
@@ -10,6 +10,7 @@ ATF_TESTS_SH+= if_bridge_test
ATF_TESTS_SH+= if_clone_test
ATF_TESTS_SH+= if_gif
ATF_TESTS_SH+= if_lagg_test
+ATF_TESTS_SH+= if_stf
ATF_TESTS_SH+= if_tun_test
ATF_TESTS_SH+= if_vlan
diff --git a/tests/sys/net/if_stf.sh b/tests/sys/net/if_stf.sh
new file mode 100644
index 000000000000..af53f7bdb5dd
--- /dev/null
+++ b/tests/sys/net/if_stf.sh
@@ -0,0 +1,84 @@
+# $FreeBSD$
+#
+# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
+#
+# Copyright (c) 2021 Rubicon Communications, LLC (Netgate)
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
+. $(atf_get_srcdir)/../common/vnet.subr
+
+atf_test_case "6to4" "cleanup"
+6to4_head()
+{
+ atf_set descr 'Test 6to4'
+ atf_set require.user root
+}
+
+6to4_body()
+{
+ vnet_init
+ if ! kldstat -q -m if_stf; then
+ atf_skip "This test requires if_stf"
+ fi
+ if ! kldstat -q -m if_gif; then
+ atf_skip "This test requires if_stf"
+ fi
+
+ epair=$(vnet_mkepair)
+
+ vnet_mkjail relay ${epair}a
+ jexec relay ifconfig lo0 inet6 2001:db8::1/64 up
+ jexec relay ifconfig ${epair}a 192.0.2.1/24 up
+ # Simple gif to terminate 6to4
+ gif=$(jexec relay ifconfig gif create)
+ jexec relay ifconfig $gif inet6 2002:c000:0201::1/64 up no_dad
+ jexec relay ifconfig $gif tunnel 192.0.2.1 192.0.2.2
+ jexec relay route -6 add default -interface $gif
+
+ vnet_mkjail client ${epair}b
+ jexec client ifconfig ${epair}b 192.0.2.2/24 up
+ stf=$(jexec client ifconfig stf create)
+ jexec client ifconfig $stf inet6 2002:c000:0202::1/32 up no_dad
+ jexec client route -6 add default 2002:c000:0201::1
+
+ # Sanity check
+ atf_check -s exit:0 -o ignore \
+ jexec client ping -c 1 192.0.2.1
+ # 6to4 direct
+ atf_check -s exit:0 -o ignore \
+ jexec client ping6 -c 1 2002:c000:0201::1
+
+ # "Wider internet"
+ atf_check -s exit:0 -o ignore \
+ jexec client ping6 -c 1 2001:db8::1
+}
+
+6to4_cleanup()
+{
+ vnet_cleanup
+}
+
+atf_init_test_cases()
+{
+ atf_add_test_case "6to4"
+}